/***************************************************************************
                             X - File Renamer                        
                             -------------------
    begin                : Sun Dec 23 2001
    copyright            : (C) 2001 by Deak Peter
    email                : deakpe@delfin.klte.hu
 ***************************************************************************/

#include <qvariant.h>
#include <qwidget.h>
#include <qlist.h>
#include <qpoint.h>
#include <qpopupmenu.h>

#include "MainWidget.h"
#include "slave.h"
#include "calc.h"
#include "Widget2.h"
#include "help.h"
#include "question.h"

#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qtabwidget.h>
#include <qradiobutton.h>
#include <qdir.h>

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <pcre.h>

#ifdef _TRUTF_TR_
#define trUtf8 tr 
#endif

#ifdef _WIN32

#include <iostream.h>
#include <malloc.h>

#else 

#include <iostream>

#include <alloc.h>
#include <dirent.h>

using std::cout;
using std::cerr;
using std::endl;

#endif

/****************************************************************************
 Builder methods
*****************************************************************************/
int WWSlave::undothis()
 {
     char out[256];
     strcpy(cstr,"<>*");
     dir = 0;
     ww->TextLabel4_2->setText(  "c - '' - '' "  );
     ww->ExampleLabel->setText(  cstr  );
     ww->LineEditFind->setText("");
     ww->LineEditReplace->setText("");

     if(!strcmp(orig_str,""))
       sprintf(out,"%s",cstr);
     else
       sprintf(out,"%s|%s",orig_str,cstr);
     ww->hs->mv->ControlString->setText(out);

     
     return 0;
 }
int WWSlave::undoall()
 {
     strcpy(orig_str,"");
     undothis();
     return 0;
 }
/*******************************************************************************/
// Third tab box
int WWSlave::caseChanged()
 {
   char out[256];
   mode = 2;
   if(ww->RadioButton1_w3->isOn()) ww->TextLabel4_3->setText( "ai"  );
   if(ww->RadioButton2_w3->isOn()) ww->TextLabel4_3->setText( "al"  ); 
   if(ww->RadioButton3_w3->isOn()) ww->TextLabel4_3->setText( "au"  );  
   if(ww->RadioButton4_w3->isOn()) ww->TextLabel4_3->setText( "abu"  ); 
   if(ww->RadioButton5_w3->isOn()) ww->TextLabel4_3->setText( "abl"  ); 
   if(ww->RadioButton6_w3->isOn()) ww->TextLabel4_3->setText( "awu"  ); 
   if(ww->RadioButton7_w3->isOn()) ww->TextLabel4_3->setText( "awl"  );

   if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
      sprintf(out,"%s",(const char *)ww->TextLabel4_3->text());
   else
      sprintf(out,"%s|%s",orig_str,(const char *)ww->TextLabel4_3->text());
   ww->hs->mv->ControlString->setText(out);

   return 0;      
 }
/*******************************************************************************/
// Second tab box
int WWSlave::tab2()
 {
  mode = 1;
  int i,m=0;
  char a[256],b[256],out[256];

  if(ww->LineEditFind->text().isEmpty()) strcpy(a," ");
  else  strcpy(a,(const char *)ww->LineEditFind->text());
  if(ww->LineEditReplace->text().isEmpty()) strcpy(b," ");
  else  strcpy(b,(const char *)ww->LineEditReplace->text());

// checking <> 
  for(i=0;i<(int)strlen(a);i++)
    if(a[i] == '<' || a[i] == '>')
     {
       QMessageBox::warning(ww,trUtf8("Error"),trUtf8("You musn't use the < and > characters!"),1,0);
      return 0;
     }
  for(i=0;i<(int)strlen(b);i++)
    if(b[i] == '<' || b[i] == '>')
     {
      QMessageBox::warning(ww,trUtf8("Error"),trUtf8("You musn't use the < and > characters!"),1,0);
      return 0;
     }

 // checking ' and " 

  for(i=0;i<(int)strlen(a);i++) if(a[i] == '\"') m = 1;
  for(i=0;i<(int)strlen(b);i++) if(b[i] == '\"') m = 1;

  if(!m)
    sprintf(cstr,"c - \"%s\" - \"%s\"",a,b);
  else
   {
    m = 0;
    for(i=0;i<(int)strlen(a);i++) if(a[i] == '\'') m = 1;
    for(i=0;i<(int)strlen(b);i++) if(b[i] == '\'') m = 1;
    if(!m)
     sprintf(cstr,"c - \'%s\' - \'%s\'",a,b);
    else
     {
      QMessageBox::warning(ww,trUtf8("Error"),trUtf8("The strings contain illegal characters! \'/\" "),1,0);
      return 0;
     }
   }

  ww->TextLabel4_2->setText(  cstr  );


  if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
      sprintf(out,"%s",cstr);
  else
      sprintf(out,"%s|%s",orig_str,cstr);
  ww->hs->mv->ControlString->setText(out);

  return 0;
 }
/*******************************************************************************/
//First tab box
int WWSlave::returnTo1()
 {
     strcpy(cstr,(const char *)ww->ExampleLabel->text());
     mode = 0;
     return 0;
 }
/****************************************************************************/
int WWSlave::changed()
 {
  char out[256];
  if(mode) returnTo1();

  int i=strlen(cstr);
  if( !dir  && ww->InterpretDir->currentItem())
   {
    reverseStr(cstr);
    reverseSubStr(cstr);
    dir = 1;
   }
  else if(dir  && !ww->InterpretDir->currentItem())
   {
    reverseStr(cstr);
    reverseSubStr(cstr);
    dir = 0;
   }

  if(dir) reverseStr(cstr);
  if(ww->EndAction->currentItem())  cstr[i-1] = '!';
  else                              cstr[i-1] = '*';
  if(dir) reverseStr(cstr);

  ww->ExampleLabel->setText(  cstr  );

  if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
    sprintf(out,"%s",cstr);
  else
    sprintf(out,"%s|%s",orig_str,cstr);   
  ww->hs->mv->ControlString->setText(out);

  return 0;
 }
/*************************************************************************/
void WWSlave::conc(char *co)
 {
  if(mode) returnTo1();

  int i=strlen(cstr);
  if(dir) reverseStr(cstr);

  cstr[i-1] = '\0';
  sprintf(cstr,"%s%s",cstr,co);

  if(dir) reverseStr(cstr);
  changed();
 }
 
int WWSlave::addMOREandCLOSE()
 {
  PageChanged(); //if the command concate mode checked meantime.
  ww->close();
  return 0;
 }
  
int WWSlave::PageChanged()
 {
  char out[256];

  switch(ww->TabWidget->currentPageIndex())
   {
    case 0:

      if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
        sprintf(out,"%s",cstr);
      else
        sprintf(out,"%s|%s",orig_str,cstr);   
      ww->hs->mv->ControlString->setText(out);
      break;

    case 1:
      if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
        sprintf(out,"%s",(const char *)ww->TextLabel4_2->text());
      else
        sprintf(out,"%s|%s",orig_str,(const char *)ww->TextLabel4_2->text());
      ww->hs->mv->ControlString->setText(out);
      break;
    
   case 2:      
      if(!strcmp(orig_str,"") || !ww->concMode->isChecked())
        sprintf(out,"%s",(const char *)ww->TextLabel4_3->text());
      else
        sprintf(out,"%s|%s",orig_str,(const char *)ww->TextLabel4_3->text());
      ww->hs->mv->ControlString->setText(out);
      break;
    }      
  return 0;
 } 

/***************************************************************************/
int WWSlave::bcb()
 { conc("B_");  return 0; }

int WWSlave::nb()
 { conc("n_");  return 0; }

int WWSlave::lcb()
 { conc("L_");  return 0; }

int WWSlave::scb()
 { conc("-_");  return 0; }

int WWSlave::hcb()
 { conc("+_");  return 0; }

int WWSlave::dcub()
 { conc(".!_");  return 0;}

int WWSlave::hcub()
 { conc(".*_");  return 0;}
/***************************************************************************/
int WWSlave::itb()
 {
  if(mode) returnTo1();

  char t[256],t2[256];
  if(ww->ITextLineEdit->text().isEmpty())  sprintf(t,"< >_");
  else
   {
    strcpy(t2,(const char*)ww->ITextLineEdit->text());
    for(int i=0;i<(int)strlen(t2);++i)
      if(t2[i] == '<' || t2[i] == '>' )
        {
          QMessageBox::warning(ww,trUtf8("Error"),trUtf8("You musn't use the < and > characters!"),1,0);
          return 0;
        }
    if(dir) reverseStr(t2);
    sprintf(t,"<%s>_",t2);
   }
  conc(t);
  return 0;
 }
/***************************************************************************/
int WWSlave::imp3tb()
 {
  if(mode) returnTo1();

  char t[256],t2[10];

  switch(ww->Mp3TagList->currentItem())
   {
    case 0: strcpy(t2,"Ta");  break;
    case 1: strcpy(t2,"Tt");  break;
    case 2: strcpy(t2,"Tl");  break;
    case 3: strcpy(t2,"Ty");  break;
    case 4: strcpy(t2,"Tc");  break;
   }

  if(dir) reverseStr(t2);
  sprintf(t,"%s_",t2);
  conc(t);
  return 0;
 }
/*************************************************************************/
void reverseStr(char * in)
 {
  Calc::strRev(in);
  for(int i=0;i<(int)strlen(in);i++)
   {
    if( in[i] == '<' ) in[i] = '>';
    else if( in[i] == '>' ) in[i] = '<';
   }
 }

char * lowercase_str(char * in)
 {
  int i;
  char *out = new char[strlen(in)+1];
  for( i = 0 ; i < (int)strlen(in) + 1 ; i++ )
    out[i] = tolower(in[i]);
  return out; 
 }

//------------------------------------------------------------------------
void reverseSubStr(char *in)
 {
  int i,j;
  char tmp[256];

  for(i=0;i<(int)strlen(in);i++)
   {
    if(in[i] == '<')
     {
       for(++i,j=0;in[i]!='>';++i,++j)
          tmp[j] = in[i];
       tmp[j] = '\0';
       Calc::strRev(tmp);
       for(--j;j >=0;j--) in[(i-strlen(tmp))+j] = tmp[j];
     }
   }
 }
/*************************************************************************/
WWSlave::WWSlave(WizardForm *w)
 {
   ww = w;

   strcpy(orig_str,(const char *)w->hs->mv->ControlString->text());

   strcpy(cstr,"<>*");
   dir = 0;
   ww->TextLabel4_2->setText(  "c - '' - '' "  );
   ww->ExampleLabel->setText(  cstr  );
   mode = 0;
 }
/*************************************************************************
  Slots of MainWidget:
**************************************************************************/
HySlave::HySlave(MainWidget *w)
 {
      mv = w;

      dirs=0;
      ftypes = NULL;
      mv->ProgressBar->reset();
      mv->ProgressBar->setIndicatorFollowsStyle(false);
      mv->ProgressBar->setTotalSteps( 10 );
      mv->ProgressBar->setProgress( 10 ); ;;;
      mv->ProgressBar->setProgress( 0 );
 };
/*************************************************************************/
int HySlave::srename()
 {
  if(!dirs) return 0;

  FILE *test;
  int return_value=0;
  int i,filenum,flag=1,n;
  QString con = mv->ControlString->text();
  Calc * calc = new Calc((const char *)con);
  char old[512],*ne,nam[512];
  
  int flag_all=ONLY_THIS;
  int flag_os =-1;
  int flag_t  =NO_TEMP;
  

  if(smodify()) return 0;

  mv->ProgressBar->setIndicatorFollowsStyle(false);

  filenum = 0;
  mv->ProgressBar->setTotalSteps( n=(int)mv->SourceList->count () );
  for(i=0;i<n;i++)
    if(mv->SourceList->isSelected (i))
     {
       strcpy(old,(const char *)mv->SourceList->text (i));
       strcpy(nam,(const char *)mv->wdir->at((uint)i));
       sprintf(nam,"%s/%s",nam,old);
       ne = calc->fCutEx(old,nam,filenum);
       if(!strcmp(ne,"-nothing- !!!")) continue;
       if(mv->CheckBox64->isOn())
        if(flag)
         if(strlen(ne) > 64)
          {
           flag = 0;
           QMessageBox::warning(mv,trUtf8("Warning!"),trUtf8("There is more than 64 char. long new filename!"),1,0);
          }
       sprintf(old,"%s/%s",(const char *)mv->wdir->at((uint)i),ne);
       if(calc->getFail())
        {
         //??? what happend ?
         return 0;
        }
       if(strcmp(nam,old)) 
       {
        if(flag_all==ONLY_THIS || flag_os != OVERWRITE )
         {
          test=NULL;
          test=fopen(old,"r");

          if(test!=NULL)
           {
       
              fclose(test);
              test = NULL;
              if(flag_all == DO_ALL && flag_os == SKIP)  continue;

              //what to to now?...ask the user
              Question *qud=new Question(0," ",true,0);
              qud->setFileName(old);
              qud->exec();
              flag_all = qud->all;
              flag_t   = qud->tempMode;
              flag_os  = qud->whatToDo;
              delete qud;
     
              if(flag_os == SKIP)  continue;
              if(flag_os == EXIT) //abort renaming.. 
                {
                 if(calc != NULL) delete calc; calc = NULL;
                 mv->SourceList->clear();
                 mv->ProgressBar->setProgress( n );
                 return 0;
                } 
            }
          }
          
       //cerr <<"mv "<<nam<<" "<<old<<endl;  
       if(flag_t == NO_TEMP)
         {
          return_value = rename(nam,old);
         }  
       else
         {
           char temp_file[256];
           sprintf(temp_file,"%s/renamer_temp_file",(const char *)mv->wdir->at((uint)i));
           return_value = rename(nam,temp_file); //add temporally filename
           if(return_value == 0 )
              return_value = rename(temp_file,old);
           if(flag_all==ONLY_THIS) flag_t=NO_TEMP;	
         }
         
        if(return_value != 0)
         {
           QMessageBox::warning(mv,trUtf8("Error"),trUtf8("I coudn't rename the file(s) !"),1,0);
           return 0;
         }
        } 
       strcpy(old,"");	
       mv->ProgressBar->setProgress( i );
       free(ne);
       filenum ++;
     }
  if(calc != NULL) delete calc; calc = NULL;
  mv->SourceList->clear();
  mv->ProgressBar->setProgress( n );

  return 0;
 }
/*************************************************************************/
int HySlave::smodify()
 {
  if(!dirs) return 0;

  int i,filenum;
  QString con = mv->ControlString->text();
  Calc * calc = new Calc((const char *)con);
  char old[256],*ne,nam[512];

  mv->ProgressBar->setProgress( 0 );
  mv->TargetList->clear();

  filenum = 0;
  for(i=0;i<(int)mv->SourceList->count ();i++)
   {
    if(mv->SourceList->isSelected (i))
     {
       strcpy(old,(const char *)mv->SourceList->text (i));
       strcpy(nam,(const char *)mv->wdir->at((uint)i));
       sprintf(nam,"%s%s",nam,old);
       ne = calc->fCutEx(old,nam,filenum);
       if(calc->getFail())
        {

         if(calc != NULL) delete calc; calc = NULL;
         mv->TargetList->clear();
         mv->TargetList->insertItem( trUtf8( "There is not correct control string." ) );
         return 1;
        }
       mv->TargetList->insertItem( ne );
       free(ne);
       filenum ++;
     }
    else
       if(mv->ShowUnsel->isOn())
        {
         mv->TargetList->insertItem(  mv->SourceList->text (i) );
        }
    }
  if(calc != NULL) delete calc; calc = NULL;
  return 0;
 }
/*******************************************************************/
int HySlave::sfilter()
 {
  if(!dirs) return 0;

  pcre *pattern;
  char patt[256];
  char str [512];
  int  match;
  int  offsets[99];
  pcre_extra *hints;
  const char * error;
  int  errptr,i;

  mv->ProgressBar->setProgress( 0 );
  strcpy(patt,(const char *)mv->FilterLineEdit->text());
  pattern  = pcre_compile(patt, 0, &error, &errptr, NULL);
  if(pattern == NULL)
   {
    sprintf(str,"%s %d: %s\n",(const char *)trUtf8("Error in regex at offset "), errptr, error);
    QMessageBox::warning(mv,"Error",str,1,0);
    return 0;
   }
  hints    = pcre_study(pattern, 0, &error);
  if(error != NULL)
   {
    sprintf(str,"%s: %s\n",(const char *)trUtf8("Error while studing regex:"), error);
    QMessageBox::warning(mv,"Error",str,1,0);
    return 0;
   }

  for(i=0;i<(int)mv->SourceList->count();i++)
   {
    strcpy(str,(const char *)mv->SourceList->text (i));
    match = pcre_exec(pattern, hints, str, strlen(str), 0, 0, offsets, 99);
    mv->SourceList->setSelected(i, match == 1 ? true : false );
   }
  return 0;
 }
/*******************************************************************/
int HySlave::open_from_dialog( void )
 {
  QString dir;
  
  dir = QFileDialog::getExistingDirectory("",mv,trUtf8("name"));
  if(dir.isEmpty())
     return 0;

  return opendir((char *)(const char *)dir,1);
 }
/*******************************************************************/ 
int HySlave::opendir(char *dirname , int clear )
 {
  int i,j;
  QString curr_dir;
  QDir   *work_dir;
  
  mv->ProgressBar->setProgress( 0 );
  if(dirname == NULL)
      return 0;
  else curr_dir = dirname;       
  cout << "Reading directory :" << curr_dir <<endl;


  if(clear)
   {
    mv->SourceList->clear();
    mv->TargetList->clear();
    mv->wdir->clear();
    mv->TargetList->insertItem( trUtf8( "There is not correct control string." ) );
   }
  
  work_dir= new QDir(curr_dir);  
  if(!work_dir->isReadable())
   {
    cerr <<"Cannot open the directory"<<endl;
    QMessageBox::warning(mv,trUtf8("Error"),trUtf8("I Could not open the directory"),1,0);
    return -1;
   }


  if(ftypes != NULL)
   {
    delete [] ftypes;
    ftypes = NULL;
   }
  ftypes = new int[1024]; j=i=0;

  const QFileInfoList *list = work_dir->entryInfoList();
  QFileInfoListIterator it( *list );
  QFileInfo *fi;
  
  for( ; (fi = it.current()) != 0 ; ++it)
    {
     if(!strcmp("." ,(const char *)fi->fileName()) ||
        !strcmp("..",(const char *)fi->fileName())  )
          continue;

     if(fi->isDir() && mv->RecCheckBox->isOn())
      { //Recursive
        char nextDir[256];
        sprintf(nextDir,"%s/%s",(const char *)curr_dir,(const char *)fi->fileName());
        opendir(nextDir,0);
      }
     else
      {
       mv->SourceList->insertItem(fi->fileName());
       mv->wdir->append(curr_dir);
       //cerr <<"be<<"<<mv->wdir->count() <<endl;

       if(fi->isDir())
         ftypes[i++] = j;
       ++j;
      }
    }

   ftypes[i++] = -1;
   mv->SourceList->selectAll(true);
   dirs=1;
 return  0;
 }
/*************************************************************************/
int HySlave::sabout()
 {
   mv->ProgressBar->setProgress( 0 );
   QMessageBox::about(mv,trUtf8("Renamer by Hyper"),
   trUtf8("File Renamer   version 0.97 \n\nAuthor: Pe'ter Dea'k deakpe@delfin.klte.hu\nCopyright (C) 2002 by Peter Deak\n(GPL) ")
   );
   return 0;
 }
/*************************************************************************/
int HySlave::shelp()
 {
  mv->ProgressBar->setProgress( 0 );
  Renamer_Help * rm = new Renamer_Help(0,trUtf8("help"));
  rm->show();
  return 0;
 }
/*************************************************************************/
int HySlave::wizard()
 {
   mv->ProgressBar->setProgress( 0 );
   WizardForm *ww = new WizardForm(this,0,"WizardWidget");
   ww->show();
   return 0;
 }
/*************************************************************************/
int HySlave::unseldirs()
 {
   if(!dirs) return 0;
   int n;
   mv->ProgressBar->setProgress( 0 );

   if(mv->RecCheckBox->isOn()) return 0; //needn't to do

   for(int i=0;(n = ftypes[i]) != -1 ;i++)
      mv->SourceList->setSelected(n,false);
   return 0;
 }
/******************************************************************************/
int HySlave::selall()
 {
  if(!dirs) return 0;
  mv->SourceList->selectAll(true);
  return smodify();
 }
/******************************************************************************/
int HySlave::dselall()
 {
  if(!dirs) return 0;
  mv->SourceList->selectAll(false);
  return smodify();
 }
/******************************************************************************/
int HySlave::closedir()
 {
  if(!dirs) return 0;
  mv->SourceList->clear();
  mv->wdir->clear();
  dirs=0;
  return smodify();
 }
/*************************************************************************/
int HySlave::popp(QListBoxItem *t,const QPoint& e)
 {
    QPopupMenu*  MList = new QPopupMenu(mv,"PopupMenu");

    MList->insertItem( trUtf8("Select all"), this, SLOT(selall()) );
    MList->insertItem( trUtf8("UnSelect All"), this, SLOT(dselall()) );
    MList->insertItem( trUtf8("Invert selection"), mv->SourceList, SLOT(invertSelection()) );
    MList->insertSeparator();
    MList->insertItem( trUtf8("Unselect Directories"), this, SLOT(unseldirs()) );
    MList->insertSeparator();
    MList->insertItem( trUtf8("Free list!"), this, SLOT(closedir()) );

    MList->popup( e );

    smodify();
    return 0;
 }
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
